import java.util.*;
import java.io.*;

class interactive_as {
    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int maxn = in.nextInt();
        int maxH = in.nextInt();
        int[] lo = new int[maxH + 1];
        int[] hi = new int[maxH + 1];
        Arrays.fill(hi, maxn + 1);

        while (count(lo, hi) > 1) {
            int r = findMax(lo, hi);
            int l = findMin(lo, hi);

            int end = r;

            while (r > l + 1) {
                int m = (l + r) / 2;
                long v = 0;
                long lv = 0;
                for (int i = 0; i < lo.length; i++) {
                    v += hi[i] - lo[i];
                    if (lo[i] < hi[i] && m > lo[i]) {
                        if (m <= hi[i]) {
                            lv += m - lo[i];
                        } else {
                            lv += hi[i] - lo[i];
                        }
                    }
                }

                if (lv > v / 2) {
                    r = m;
                } else {
                    l = m;
                }
            }

            out.println("check " + l + " " + end);
            out.flush();
            String ans = in.next();

            if (ans.equals("No")) {
                for (int i = 0; i < lo.length; i++) {
                    if (hi[i] > l) {
                        hi[i] = l;
                    }
                    if (hi[i] <= lo[i]) {
                        hi[i] = lo[i];
                    }
                }
            } else {
                for (int i = 0; i < lo.length; i++) {
                    if (lo[i] < l) {
                        lo[i] = l;
                    }
                    if (lo[i] >= hi[i]) {
                        lo[i] = hi[i];
                    }
                }
            }

            for (int i = 0; i < lo.length; i++) {
                lo[i] += i;
                hi[i] += i;
            }

        }

        int ans = 0;
        for (int i = 0; i < lo.length; i++) {
            if (lo[i] < hi[i]) {
                ans = lo[i];
            }
        }
        out.println("answer " + ans);
    }

    long count(int[] lo, int[] hi) {
        long r = 0;
        for (int i = 0; i < lo.length; i++) {
            r += hi[i] - lo[i];
        }
        return r;
    }

    int findMin(int[] lo, int[] hi) {
        int r = Integer.MAX_VALUE;
        for (int i = 0; i < lo.length; i++) {
            if (lo[i] < hi[i]) {
                r = Math.min(r, lo[i]);
            }
        }
        return r;
    }

    int findMax(int[] lo, int[] hi) {
        int r = Integer.MIN_VALUE;
        for (int i = 0; i < lo.length; i++) {
            if (lo[i] < hi[i]) {
                r = Math.max(r, hi[i]);
            }
        }
        return r;
    }

    public void run() {
        try {
            in = new FastScanner(System.in);
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream is) {
            br = new BufferedReader(new InputStreamReader(is));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new interactive_as().run();
    }
}